%define DATE 20040701
%define gcc_version 3.2.3
%define gcc_release 56
%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%ifarch %{ix86} alpha ia64 ppc x86_64 s390
%define build_ada 1
%else
%define build_ada 0
%endif
%define build_java 1
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif
%define jpackage_priority 100
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc
Version: %{gcc_version}
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
Source2: libgcj-java-placeholder.sh
Source3: libgcj-javac-placeholder.sh
URL: http://gcc.gnu.org
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
# Need binutils with -pie support
# Need binutils with .weakref support
BuildRequires: binutils >= 2.14.90.0.4-42
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12
%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif
Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
# Need .weakref support
Requires: binutils >= 2.14.90.0.4-42
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= %{version}-%{release}
Obsoletes: gcc3
Obsoletes: egcs
%ifarch sparc sparc64
Obsoletes: egcs64
%endif
Prereq: /sbin/install-info
AutoReq: true

Patch1: gcc32-multi32-hack.patch
Patch2: gcc32-ice-hack.patch
Patch3: gcc32-ppc64-m32-m64-multilib-only.patch
Patch4: gcc32-bison-1.875c.patch
Patch5: gcc32-i386-prefetch-sse.patch
Patch6: gcc32-convert-move.patch
Patch7: gcc32-libjava-jar-timestamps.patch
Patch8: gcc32-c++-friend-templ-member.patch
Patch9: gcc32-c++-scope-nesting.patch
Patch10: gcc32-libstdc++-symver.patch
Patch11: gcc32-java-intlex.patch
Patch12: gcc32-java-nan.patch
Patch13: gcc32-dwarf2-pruning-keep-spec.patch
Patch14: gcc32-java-bytecode.patch
Patch15: gcc32-pr3581.patch
Patch16: gcc32-libstdc++-limits.patch
Patch17: gcc32-s390-reload-dup.patch
Patch18: gcc32-ppc-altivec-ap.patch
Patch19: gcc32-ppc-mpowerpc64.patch
Patch20: gcc32-null-pointer-check-noncc0.patch
Patch21: gcc32-ppc-movdi_internal64.patch
Patch22: gcc32-c++-reregister-specialization.patch
Patch23: gcc32-c++-pr7566.patch
Patch24: gcc32-c++-pass-by-invisible-ref.patch
Patch25: gcc32-c++-unitialized-self-ref.patch
Patch26: gcc32-tablejump-cleanup.patch
Patch27: gcc32-libstdc++-fully-dynamic-strings.patch
Patch28: gcc32-Winline-doc.patch
Patch29: gcc32-ia64-expand_load_address.patch
Patch30: gcc32-demangle-pr16240.patch
Patch31: gcc32-debug-cdtor.patch
Patch32: gcc32-cxa_demangle-ambiguity.patch
Patch33: gcc32-c++-pr10558.patch
Patch34: gcc32-libstdc++-pr9659.patch
Patch35: gcc32-libstdc++-symver2.patch
Patch36: gcc32-pr19005.patch
Patch37: gcc32-rh149250.patch
Patch38: gcc32-rh156185.patch
Patch39: gcc32-rh156291.patch
Patch40: gcc32-pr18300.patch
Patch41: gcc32-gnuc-rh-release.patch
Patch42: gcc32-weakref.patch
Patch43: gcc32-pr13106.patch
Patch44: gcc32-ppc64-stack-boundary.patch
Patch45: gcc32-pr12799.patch
Patch46: gcc32-pr13041.patch
Patch47: gcc32-pr26208.patch
Patch48: gcc32-rh173224.patch
Patch49: gcc32-rh180778.patch
Patch50: gcc32-rh181894.patch
Patch51: gcc32-rh186252.patch
Patch52: gcc32-pr26208-workaround.patch
Patch53: gcc32-libgcc_eh-hidden.patch

%define _gnu %{nil}
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version 3.2.3.
You'll need this package in order to compile C code.

%package -n libgcc
Summary: GCC version 3.2.3 shared support library
Group: System Environment/Libraries
Autoreq: false

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}
Obsoletes: gcc3-c++
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Obsoletes: libstdc++3
Autoreq: true

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++3-devel
Autoreq: true

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Obsoletes: gcc3-objc
Autoreq: true

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package g77
Summary: Fortran 77 support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: /sbin/install-info
Obsoletes: gcc3-g77
Autoreq: true

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.

%package -n libf2c
Summary: Fortran 77 runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj >= %{version}, libgcj-devel >= %{version}, zlib-devel
Obsoletes: gcc3-java
Prereq: /sbin/install-info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Prereq: /sbin/install-info
PreReq: %{_sbindir}/alternatives
Requires: zip >= 2.1
Obsoletes: gcc-libgcj
Obsoletes: libgcj3
# Kaffe includes jar too
Conflicts: kaffe
Autoreq: true

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj = %{version}
Obsoletes: libgcj3-devel
Autoreq: true

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package sparc32
Summary: The C compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
Autoreq: true

%description sparc32
This package contains the GNU C compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-sparc32
Summary: The C++ compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-sparc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
Autoreq: true

%description c++-sparc32
This package contains the GNU C++ compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package ppc32
Summary: The C compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
Autoreq: true

%description ppc32
This package contains the GNU C compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-ppc32
Summary: The C++ compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-ppc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
Autoreq: true

%description c++-ppc32
This package contains the GNU C++ compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info
%ifarch ia64
Obsoletes: gnupro
%endif
Autoreq: true

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%package gnat
Summary: Ada 95 support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}, libgnat = %{version}-%{release}
Obsoletes: gnat-devel, gcc3-gnat
Prereq: /sbin/install-info
Autoreq: true

%description gnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes development tools,
the documents and Ada 95 compiler.

%package -n libgnat
Summary: GNU Ada 95 runtime shared libraries
Group: System Environment/Libraries
Obsoletes: gnat libgnat3
Autoreq: true

%description -n libgnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.

%prep
%setup -q -n gcc-%{version}-%{DATE}
%ifarch sparc ppc
%patch1 -p0 -b .multi32-hack~
%endif
%patch2 -p0 -b .ice-hack~
%patch3 -p0 -b .ppc64-m32-m64-multilib-only~
%patch4 -p0 -b .bison-1.875c~
%patch5 -p0 -b .i386-prefetch-sse~
%patch6 -p0 -b .convert-move~
%patch7 -p0 -b .libjava-jar-timestamps~
%patch8 -p0 -b .c++-friend-templ-member~
#%patch9 -p0 -b .c++-scope-nesting~
%patch10 -p0 -b .libstdc++-symver~
%patch11 -p0 -b .java-intlex~
%patch12 -p0 -b .java-nan~
%patch13 -p0 -b .dwarf2-pruning-keep-spec~
%patch14 -p0 -b .java-bytecode~
%patch15 -p0 -b .pr3581~
%patch16 -p0 -b .libstdc++-limits~
%patch17 -p0 -b .s390-reload-dup~
%patch18 -p0 -b .ppc-altivec-ap~
%patch19 -p0 -b .ppc-mpowerpc64~
%patch20 -p0 -b .null-pointer-check-noncc0~
%patch21 -p0 -b .ppc-movdi_internal64~
%patch22 -p0 -b .c++-reregister-specialization~
%patch23 -p0 -b .c++-pr7566~
%patch24 -p0 -b .c++-pass-by-invisible-ref~
%patch25 -p0 -b .c++-unitialized-self-ref~
%patch26 -p0 -b .tablejump-cleanup~
%patch27 -p0 -b .libstdc++-fully-dynamic-strings~
%patch28 -p0 -b .Winline-doc~
%patch29 -p0 -b .ia64-expand_load_address~
%patch30 -p0 -b .demangle-pr16240~
%patch31 -p0 -b .debug-cdtor~
%patch32 -p0 -b .cxa_demangle-ambiguity~
%patch33 -p0 -b .c++-pr10558~
%patch34 -p0 -b .libstdc++-pr9659~
%patch35 -p0 -b .libstdc++-symver2~
%patch36 -p0 -b .pr19005~
%patch37 -p0 -b .rh149250~
%patch38 -p0 -b .rh156185~
%patch39 -p0 -b .rh156291~
%patch40 -p0 -b .pr18300~
%patch41 -p0 -b .gnuc-rh-release~
%patch42 -p0 -b .weakref~
%patch43 -p0 -b .pr13106~
%patch44 -p0 -b .ppc64-stack-boundary~
%patch45 -p0 -b .pr12799~
%patch46 -p0 -b .pr13041~
%patch47 -p0 -b .pr26208~
%patch48 -p0 -b .rh173224~
%patch49 -p0 -b .rh180778~
%patch50 -p0 -b .rh181894~
%patch51 -p0 -b .rh186252~
%patch52 -p0 -b .pr26208-workaround~
%patch53 -p0 -b .libgcc_eh-hidden~

perl -pi -e 's/3\.2\.4/3.2.3/' gcc/version.c gcc/f/version.c gcc/ada/gnatvsn.ads
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(Red Hat Linux %{version}-%{gcc_release}\)/' gcc/version.c gcc/f/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(%{version}-%{gcc_release}\)/' gcc/ada/gnatvsn.ads
perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/bugzilla.redhat.com\/bugzilla\/>"/' gcc/system.h
# The version string is now longer than 32 bytes and the line containing it
# doesn't fit into 80 columns
#perl -pi -e 's/:= 32/:= 64/;s/(Gnat_Version_String.*:=)/\1\n    /' gcc/ada/gnatvsn.ads

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch ppc ppc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit \
%if !%{build_ada}
	--enable-languages=c,c++,objc,java,f77 \
%endif
%if !%{build_java}
	--disable-libgcj \
%endif
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif

make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap-lean
#make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap

%if %{build_ada}
# This doesn't work with -jN
make -C gcc BOOT_CFLAGS="$OPT_FLAGS" gnatlib-shared
make -C gcc BOOT_CFLAGS="$OPT_FLAGS" gnattools
make -C gcc/ada BOOT_CFLAGS="$OPT_FLAGS" doc
%endif

# run the tests.
make %{?_smp_mflags} -k check || :
%ifarch %{ix86}
CANONP=i686-pc-linux-gnu
%endif
%ifarch alpha
CANONP=alphaev67-unknown-linux-gnu
%endif
%ifarch ia64
CANONP=ia64-unknown-linux-gnu
%endif
if [ -n "$CANONP" ]; then
  ln -sf $CANONP ../libstdc++-v3/config/abi/%{gcc_target_platform}
  ln -sf $CANONP ../libstdc++-v3/config/abi/%{gcc_target_platform}-gnu
fi
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
if [ -d ../libstdc++-v3/config/abi/%{gcc_target_platform}-gnu ]; then
  make -C %{gcc_target_platform}/libstdc++-v3 check-abi
fi
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

%ifarch sparc ppc
# Build the -m32 only compiler which does not use long long for HOST_WIDE_INT
mkdir gcc32
cd gcc32
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
echo "#!/bin/sh" > gcc32
echo "exec `cd ../gcc; pwd`/xgcc -B `cd ../gcc; pwd`/ $OPT_FLAGS \$*" >> gcc32
chmod +x gcc32
CC=`pwd`/gcc32 CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" \
  TCFLAGS="$OPT_FLAGS" ../../gcc/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
  --enable-shared --enable-threads=posix --disable-checking \
  --with-system-zlib --enable-__cxa_atexit \
  --host=%{_target_platform}
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" cc1 cc1plus
cd ..
%endif

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3
%if %{build_java}
make -C %{gcc_target_platform}/libjava
%endif

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install
%if %{build_ada}
pushd gcc/ada
cp -a gnat-style.info* gnat_rm.info* $RPM_BUILD_ROOT%{_infodir}/
for i in gnat_ug_unx.info*; do
  sed 's/gnat_ug_unx/gnat_ug/g' $i > $RPM_BUILD_ROOT%{_infodir}/`echo $i | sed 's/gnat_ug_unx/gnat_ug/'`
done
chmod 644 $RPM_BUILD_ROOT%{_infodir}/gnat*
popd
%endif

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc

%ifarch sparc ppc
# Install the sparc/ppc -m32 only compilers
FULLPATH32=$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
mkdir -p $FULLPATH32
install -m 755 gcc32/cc1 $FULLPATH32/
install -m 755 gcc32/cc1plus $FULLPATH32/
ln -sf ../../%{gcc_target_platform}/%{gcc_version}/include $FULLPATH32/
ln -sf ../../%{gcc_target_platform}/%{gcc_version}/cpp0 $FULLPATH32/
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc ppc
cp -al $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

if [ "%{build_java}" -gt 0 ]; then
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcj.*a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $FULLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT%{_prefix}/include/gcj
fi

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif

%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.5.* libstdc++.so
%if %{build_java}
ln -sf ../../../libgcj.so.3.* libgcj.so
%endif
ln -sf ../../../libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../libgnarl-*.so.* libgnarl.so
ln -sf ../../../../libgnat-*.so.* libgnat.so
cd ..
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.5.* libstdc++.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.3.* libgcj.so
%endif
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../../%{_lib}/libgnarl-*.so.* libgnarl.so
ln -sf ../../../../../%{_lib}/libgnat-*.so.* libgnat.so
cd ..
%endif
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .

%ifarch sparc ppc
ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.5.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib/libgcj.so.3.* | sed s~/lib/~/lib64/~` 64/libgcj.so
fi
ln -sf ../`echo ../../../../lib/libg2c.so.0.* | sed s~/lib/~/lib64/~` 64/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libg2c.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libfrtbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libobjc.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf lib32/libgcj.a libgcj.a
ln -sf ../lib64/libgcj.a 64/libgcj.a
fi
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.5.* | sed s~/../lib64/~/~` 32/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib64/libgcj.so.3.* | sed s~/../lib64/~/~` 32/libgcj.so
fi
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
fi
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
fi
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a -o -name libgcc.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.1.*

%if %{build_ada}
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnarl*so*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnat*so*
%endif

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..
%find_lang %{name}

# install explanation script
pushd $RPM_BUILD_ROOT%{_prefix}/share/java
  install -m 755 %{SOURCE2} .
  install -m 755 %{SOURCE3} .
popd

# rename jpackage-conflicting tools
pushd $RPM_BUILD_ROOT%{_prefix}/bin
  mv -f rmiregistry grmiregistry
  mv -f jar gjar
  mv -f rmic grmic
popd

# rename corresponding man pages
pushd $RPM_BUILD_ROOT%{_mandir}/man1
  mv -f rmiregistry.1 grmiregistry.1
  mv -f jar.1 gjar.1
  mv -f rmic.1 grmic.1
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcc.info.gz

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
fi

%post -n cpp
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cpp.info.gz

%preun -n cpp
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
fi

%post g77
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/g77.info.gz

%preun g77
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/g77.info.gz
fi

%post java
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcj.info.gz

%preun java
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
fi

%post gnat
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz

%preun gnat
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz
fi

# Because glibc Prereq's libgcc and /sbin/ldconfig
# comes from glibc, it might not exist yet when
# libgcc is installed
%post -n libgcc -p %{_prefix}/sbin/libgcc_post_upgrade

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj
/sbin/ldconfig
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
%{_sbindir}/alternatives --install %{_bindir}/java java %{_prefix}/share/java/libgcj-java-placeholder.sh %{jpackage_priority} \
  --slave %{_bindir}/rmiregistry rmiregistry %{_bindir}/grmiregistry \
  --slave %{_mandir}/man1/rmiregistry.1.gz rmiregistry.1.gz %{_mandir}/man1/grmiregistry.1.gz
%{_sbindir}/alternatives --install %{_bindir}/javac javac %{_prefix}/share/java/libgcj-javac-placeholder.sh %{jpackage_priority} \
  --slave %{_bindir}/jar jar %{_bindir}/gjar \
  --slave %{_bindir}/rmic rmic %{_bindir}/grmic \
  --slave %{_mandir}/man1/jar.1.gz jar.1.gz %{_mandir}/man1/gjar.1.gz \
  --slave %{_mandir}/man1/rmic.1.gz rmic.1.gz %{_mandir}/man1/grmic.1.gz

%triggerpostun -n libgcj -- libgcj <= 3.2.3-37
%{_sbindir}/alternatives --auto java
%{_sbindir}/alternatives --auto javac

%ifarch ppc ppc64
%pre -n libstdc++-devel
[ -L %{_prefix}/include/c++/%{gcc_version}/ppc64-redhat-linux ] \
  && /bin/rm -f %{_prefix}/include/c++/%{gcc_version}/ppc64-redhat-linux \
  || :
%endif

%preun -n libgcj
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
fi

%postun -n libgcj
/sbin/ldconfig
if [ $1 = 0 ]; then
  %{_sbindir}/alternatives --remove java %{_prefix}/share/java/libgcj-java-placeholder.sh
  %{_sbindir}/alternatives --remove javac %{_prefix}/share/java/libgcj-javac-placeholder.sh
fi

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig

%post -n libgnat -p /sbin/ldconfig

%postun -n libgnat -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root)
%{_prefix}/bin/cc
%{_prefix}/bin/c89
%{_prefix}/bin/c99
%{_prefix}/bin/gcc
%{_prefix}/bin/gcov
%{_prefix}/bin/protoize
%{_prefix}/bin/unprotoize
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_infodir}/gcc*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_prefix}/bin/cpp
%{_mandir}/man1/cpp.1*
%{_infodir}/cpp*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cpp0
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/tradcpp0

%files -n libgcc
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1
%{_prefix}/sbin/libgcc_post_upgrade

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++
%{_prefix}/bin/g++
%{_prefix}/bin/c++
%{_prefix}/bin/c++filt
%{_mandir}/man1/g++.1*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.5*

%files -n libstdc++-devel
%defattr(-,root,root)
%{_prefix}/include/c++
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%files objc
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n libobjc
%defattr(-,root,root)
%{_prefix}/%{_lib}/libobjc.so.1*

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77
%{_prefix}/bin/f77
%{_mandir}/man1/g77.1*
%{_infodir}/g77*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/f771
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.so
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/g2c.h
%doc gcc/f/README rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_prefix}/%{_lib}/libg2c.so.0*

%if %{build_java}
%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj
%{_prefix}/bin/gcjh
%{_prefix}/bin/jcf-dump
%{_prefix}/bin/jv-scan
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/gcjh.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/jv-scan.1*
%{_infodir}/gcj*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%endif
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.a
%endif
%doc gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/bin/gjar
%{_prefix}/bin/grepjar
%{_prefix}/bin/grmic
%{_prefix}/bin/grmiregistry
%{_mandir}/man1/gjar.1*
%{_mandir}/man1/grepjar.1*
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/grmic.1*
%{_mandir}/man1/grmiregistry.1*
%{_infodir}/fastjar*
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/share/java
%{_prefix}/lib/security

%files -n libgcj-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gcj
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/org
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*
%endif

%if %{build_ada}
%files gnat
%defattr(-,root,root)
%{_prefix}/bin/gnat*
%{_infodir}/gnat*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/adalib
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/gnat1
%doc gcc/ada/ChangeLog

%files -n libgnat
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgnat-*.so.*
%{_prefix}/%{_lib}/libgnarl-*.so.*
%endif

%ifarch sparc
%files sparc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cpp0
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include

%files c++-sparc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%endif

%ifarch ppc
%files ppc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cpp0
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include

%files c++-ppc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%endif

%changelog
* Mon May 22 2006 Jakub Jelinek  <jakub@redhat.com> 3.2.3-56
- add workaround for buggy programs that link in their own unwinder
  and reexport it (#192259)
- make all globals in libgcc_eh.a hidden, so that newly (incorrectly)
  linked programs can't reexport the unwinder

* Tue Apr 25 2006 Jakub Jelinek  <jakub@redhat.com> 3.2.3-55
- fix splitting of SSE conditional move patterns (Alexandre Oliva, #173224)
- fix unwinding through signal frames (#187810, PR other/26208, glibc BZ#300)
- fix for C++ overlapping stack temporaries (Ulrich Weigand, #186252, #187909,
  PR middle-end/15054)
- fix crash in zero-initialization of mmx registers (Richard Henderson,
  Alexandre Oliva, #180778)
- report unused parameter warnings even on optimized out functions/methods
  (Alexandre Oliva, Jan Hubicka, #181894)

* Thu Nov 17 2005 Jakub Jelinek  <jakub@redhat.com> 3.2.3-54
- disable os_defines.h changes introduced in 3.2.3-45 also for
  IBM xlC compiler (#146196, IT#75174)
- fix pushdecl_class_level for OVERLOADs (Mark Mitchell,
  Alexandre Oliva, #156185)
- reword diagnostics about unresolved overloaded type
  (Alexandre Oliva, #156291, IT#70101)
- fix x86_64 compiler hang when passing object with 3+ base classes by value
  (Zak Kipling, PR target/18300, #164421, #171940, IT#76454)
- predefine __GNUC_RH_RELEASE__ macro to rpm's %%{release} (Alexandre Oliva)
- weakref attribute support, use it in <bits/gthr.h> various C++ headers
  are using (Alexandre Oliva, #165728, IT#73356)
- don't warn in templates about missing return if return type is dependent
  on template parameters (Alexandre Oliva, PR c++/13106, #169044, IT#77857)
- ensure ppc64 keeps stack 16 byte aligned even with dynamic allocation
  (alloca, VLAs), but don't rely on it in the generated code
  (Alexandre Oliva, #169111, IT#76136)
- fix invalid CC clobberation on i?86/x86_64 (Eric Botcazou,
  PR optimization/12799, #169654)
- don't assume hard frame pointer register is STACK_BOUNDARY aligned
  if frame pointer isn't used and the register has been reused
  for something else (Eric Botcazou, PR optimization/13041, #169845)

* Tue Jul 19 2005 Jakub Jelinek  <jakub@redhat.com> 3.2.3-53
- fix libstdc++ seekoff bug (Scott Snyder, #151692, IT#66065,
  PR libstdc++/9659)
- don't use .symver directives in libstdc++.a, instead
  provide hidden aliases for the obsolete symbols (#151732, IT#64710)
- fix a strength reduction bug (Jan Hubicka, #149250, IT#66328)
- fix xchgb constraints on i386 (#156104, IT#69633, PR target/19005)

* Mon Feb 28 2005 Jakub Jelinek  <jakub@redhat.com> 3.2.3-52
- change __cxa_demangle to match cxx-abi change
  http://www.codesourcery.com/archives/cxx-abi-dev/msg01877.html
  (Jason Merrill, #133406)
- fix ICE on invalid use of template without arguments as primary
  expression (Mark Mitchell, #149492, PR c++/10558)

* Sat Jan 29 2005 Jakub Jelinek  <jakub@redhat.com> 3.2.3-51
- fix c++filt/__cxa_demangle segfault on invalidly mangled names
  generated by G++ 3.4 (Ian Lance Taylor, #145781, PR c++/16240)
- disable os_defines.h changes introduced in 3.2.3-45 for non-GCC
  compilers (#144725, #146196)
- fix debugging information in in-charge constructors and
  destructors (Mark Mitchell, #146416, PR debug/11098)

* Tue Jan  4 2005 Jakub Jelinek  <jakub@redhat.com> 3.2.3-50
- fix delete_null_pointer_checks on non-cc0 targets (Alan Modra, #141694,
  IT#54408, PR rtl-optimization/14279)
- fix some reload related issues on ppc64 (David Edelsohn, #139099,
  IT#45622, PRs target/16239, target/8480, optimization/8328)
- fix ICE in regenerate_decl_from_template (Mark Mitchell, #142418,
  PR c++/7053)
- fix ICE when printing jump to case label... crosses initialization
  warning (Gabriel Dos Reis, #140830, PR c++/7566)
- fix corner case in passing by invisible reference (Alexandre Oliva,
  IT#54891, #141270)
- fix ICE on code that uses value of reference in reference's initializer
  (Alexandre Oliva, #141274, IT#36304)
- avoid moving jumptable away from corresponding jump even if there is an
  intervening barrier (Josef Zlomek, #131378)
- with -D_GLIBCXX_FULLY_DYNAMIC_STRING, STL should now avoid
  _S_empty_rep_storage (Paolo Carlini, #131030, IT#45103, PR libstdc++/16612)
- document -Winline only works for languages that use RTL inliner (Java,
  Ada, #141272, IT#28331)

* Fri Dec 17 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-49
- remove /usr/include/c++/%{version}/ppc64-redhat-linux symlink
  in %pre on ppc/ppc64 (#135611)

* Tue Oct 26 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-47
- avoid symlinks in /usr/include/c++/%{version}/ on ppc and sparc
  (#135611)
- fix a reload bug with match_dup on s390 (Ulrich Weigand, #135715)
- improve messages in libgcj placeholder scripts (Thomas Fitzsimmons,
  #130499)
- fix ppc32 ICE with -maltivec vector function arguments (Hartmut Penner,
  #134368)
- temporarily don't apply the C++ scope nesting patch (#135279,
  IT#50411)
- on PPC, disallow -m32 -mpowerpc64 and -m64 -mno-powerpc64 switch
  combinations (#132176)

* Wed Oct  6 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-46
- make the last patch work even with -ansi -pedantic-errors

* Wed Oct  6 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-45
- fix std::numeric_limits<long> on x86_64 -m32 (#132730)
- fix std::numeric_limits<float>, std::numeric_limits<double>
  and std::numeric_limits<long double>

* Tue Oct  5 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-43
- speed up string concatenation (Richard Henderson, PR c/3581, #132780)
- use libgcj-javac-placeholder.sh for javac alternative(8),
  run exec gcj -C "$@" at the end of it and gij "$@" at the end
  of libgcj-java-placeholder.sh

* Sat Aug 13 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-42
- one more gcj -C fix to make sure .class files are identical between
  32-bit and 64-bit targets (#128431)

* Fri Aug 13 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-41
- gcj fixes so that libgcj-3.2.3.jar is identical accross architectures
  (Andrew Haley, Tom Tromey, #128431, PR java/6388)
- debug info fix for nested class of template (Alexandre Oliva,
  #129841, IT#45246)
- fix for #129730 patch (Alexandre Oliva)

* Thu Aug 12 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-40
- avoid making silly copies in convert_move (Jeff Law, #127484)
- make sure all files in libgcj*.jar have identical timestamps
  accross all the architectures (#128431)
- templates and friends fix (Alexandre Oliva, #129350, IT#36406)
- c++ debug info fix (Alexandre Oliva, #129730, IT#43309)
- update the SSE prefetch patch, such that -march=i686 (and later)
  with -mcpu=pentium3 etc. still generates prefetches
- make even multilib libstdc++.so's versioned

* Wed Jul  7 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-39
- don't use SSE prefetch instructions if -mcpu= is a CPU with
  SSE prefetch, but -march= is not and -msse{2,3} is not given
  either (#127375)

* Thu Jul  1 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-38
- use %{_sbindir}/alternatives instead of update-alternatives,
  add Prereq on it, use alternatives --auto {java,javac} in
  %%triggerpostun
- work around new bison 1.875c macros

* Thu Jun 24 2004 Thomas Fitzsimmons <fitzsim@redhat.com>
- rename rmiregistry, jar and rmic binaries and their man pages and
  install alternatives-managed symlinks in their place.

* Fri Jun 17 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-37
- readd dyn-string.o into libstdc++.so and libsupc++, because
  it has been (mistakenly) exported out of libstdc++.so

* Thu Jun 17 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-36
- fix ia64 backtrace (#125204)
- fix x86-64 va_arg if temporary is needed for alignment purposes
  (Jan Hubicka)
- new demangler for both __cxa_demangle and c++filt,
  backported from GCC trunk (Ian Lance Taylor, #89228)

* Fri May 28 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-35
- fix x86_64 ICE in emit_group_store (Jan Hubicka, #122716)
- fix x86_64 miscompilation (H.J.Lu, #121600, PR target/15084)
- fix libffi bug on ia64 (#122923)

* Thu Apr 15 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-34
- fix a memory leak in __cxa_demangle

* Wed Apr 14 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-33
- support -m{arch,cpu}={prescott,nocona,k8,opteron,athlon64,athlon-fx}
  (#119023)
- fix __cxa_demangle (#120493)

* Wed Mar 24 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-32
- don't use 3dNOW! prefetches in x86-64 libgcj
  (H.J.Lu, #119022, PR target/14326)
- fix PR c++/7718 (Nathan Sidwell)

* Fri Mar 12 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-31
- adjust for the bias in DW_OP_GNU_push_tls_address value,
  so that first __thread var in an object starts at 0
- make all subpackages owns all dirs in the gcc-lib tree they are using

* Sat Feb 28 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-30
- error if -march or -mcpu is used in -m64 on x86-64 with x86-64
  incompatible CPU (#116650)
- emit dwarf2 debug info for __thread vars on ppc/ppc64 (#111628)

* Wed Feb 18 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-29
- fix last java patch on ppc64
- don't imply -m3dnow with -m64 on x86-64
- fix x86-64 varargs handling without va_start (Jan Hubicka, #116068)

* Mon Feb 16 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-28
- fix initialization of aggregates with const fields and const
  vars (#114610, PR optimization/13424)
- fix scheduling on IA-64 (Eric Botcazou, #115446)
- fix endless loop in C++ frontend (Mark Mitchell, #115159,
  PR c++/10503, PR c++/10506)
- ppc and ppc64 java fixes (Franz Sirl, Alan Modra, PR target/13914)

* Tue Jan 27 2004 Jakub Jelinek  <jakub@redhat.com> 3.2.3-27
- pass RPM_OPT_FLAGS as BOOT_CFLAGS to bootstrap
- decrease string literal alignment for strlen () >= 31 strings
  on IA-32/AMD64 to 1 (-Os) or sizeof (void *) (!-Os)
- avoid needless R_.*_JU?MP_SLOT relocation in crtbegin*.o
- backport @GCC_3.4 exported routines from gcc-3_4-branch to libgcc_s.so.1
- fix __builtin_expect

* Sun Dec 28 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-26
- fix __builtin_expect in C++ code
- fix unwinding through SA_ONSTACK signal frames on IA-64
- fix unwinding through signal frames on IA-64
- BuildRequire texinfo (#111168)
- Require /sbin/install-info for libgcj (#110904)
- fix structure initialization with const fields and mostly zeros
  in the initializer (#110966)
- some more > 2GB handling fixes (Jan Hubicka)

* Fri Nov 21 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-25
- build crt files such that they are usable when doing multi-TOC
  linker optimizations on PPC64 (Alan Modra)
- fix gcj on PPC64 not emitting needed nop after branch and link
  to non-local Java method (Richard Henderson)

* Fri Nov 14 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-24
- allow ar.pfs and ar.unat in __asm clobbers on IA-64
  (Richard Henderson)

* Sun Oct 26 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-23
- fix handling of functions with > 2GB stack frames

* Wed Oct 22 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-22
- fix handling of objects larger than 2GB or 4GB (Jan Hubicka and others)
- fix Fortran COMMONs bigger than 2GB (#106542)

* Mon Oct  6 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-21
- fix ICE hack - 3.2.x doesn't do preprocessing in cc1/cc1plus unlike 3.3.x
- fix "may return with or without a value" warnings (Steven Bosscher,
  #105798, PR c/9862)
- fix AMD64 loop ICE (Jan Hubicka, #106113)
- fix PRs libstdc++/9988, libstdc++/9439, PR libstdc++/9425 (Paolo Carlini,
  Benjamin Kosnik, Issue Tracker #27546)

* Tue Sep 16 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-20
- fix -fstack-limit (#104189)
- add __attribute__((warn_unused_result)) support

* Thu Sep 11 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-19
- use --start-group -lgcc -lgcc_eh -lc --end-group when doing
  static linking

* Thu Sep  4 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-18
- export _Unwind_GetBSP@@GCC_3.3.2 from libgcc_s.so on IA-64

* Fri Aug 29 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-17
- fix linux kernel miscompilation with __builtin_expect (#102747)
- add Intel Prescott support for _mm_monitor/_mm_mwait (H.J.Lu, #103352)

* Fri Aug 15 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-16
- speed up finish_struct (Stan Shebs, Turly O'Connor)
- fix libgcc_post_upgrade on sparc64

* Thu Aug 14 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-15
- speed up regclass initialization (Mike Stump)

* Mon Aug 11 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-14
- fix C++ __attribute__(({con,de}structor)) (Mark Mitchell, PR c++/11137)
- fix IA-64 __builtin_return_address (Richard Henderson, #99220,
  PR target/11535)
- speed up get_identifier with string literal argument (Roger Sayle)

* Fri Aug  1 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-13
- update from gcc-3_2-branch
  - PR middle-end/10336
- fix an amd64 TLS pic bug
- add /usr/sbin/libgcc_post_upgrade, use it in libgcc's %%post
- remove libgcc's %%postun
- turn off autorequires for libgcc
- don't destroy argument to fold/convert/extract_muldiv (#98550)
- add -Wdeclaration-after-statement (Hans-Peter Nilsson)
- BuildRequire bison and flex (#98920)
- kill some warnings
- fix cross-jumping on s390 (#91185)

* Thu Jul 17 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-12
- honor IA-64 ABI (ie. disallow tail calls to non-local functions,
  Richard Henderson, #91056)
- fix loop causing miscompilation of ppc64 raid1 code from linux
  kernel (PR target/11087)

* Tue Jul 15 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-11
- fix empty struct moving/clearing on s390{,x}

* Tue Jul 15 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-10
- fix ppc64 unwinding through signal frames
- don't access memory below 288 bytes under $r1 on ppc64
  in libgcc_eh.a
- don't "optimize" memset (x, nonconstant, 16) on s390x
  to __multi3 plus 2 stores (Ulrich Weigand, Roger Sayle)
- PR middle-end/6600 (Roger Sayle)
- fix string-opt-8.c testcase after strcmp/strncmp fix on s390
- avoid default argument to std::__convert_from_v in 2 different
  places (#98868, #98047)
- PR optimization/11059 (Roger Sayle)
- export __gcc_personality_{v0,sj0}@@GCC_3.3.1 from libgcc_s.so
  (Richard Henderson)

* Fri Jul 11 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-9
- PR optimization/10339
- fix amd64 -fpic with volatile variable (#98518, c/11420)
- fix strength reduction causing miscompilation of pwlib on s390x
- add s390 MD_FALLBACK_STATE_FRAME_FOR
- fix ppc32 MD_FALLBACK_FRAME_STATE_FOR
- fix builtin strcmp and strncmp miscompilation
- optimize builtin sprintf (Roger Sayle)

* Wed Jun 25 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-8
- fix a bug in builtin strcpy evaluation
- optimize more cases of builtin strlen, str*cmp, strcpy, strncpy,
  fputs
- _Unwind_GetCFA and _Unwind_FindEnclosingFunction implemented
  in ia64 libgcc_s.so
- ppc32 libffi fixes (Franz Sirl)
- call a local alias of method instead of the exported
  symbols in thunks if assembler supports .set
- fix a bug in gcc driver hack for ICE analysis which caused
  some reproduceable bugs printed as non-reproduceable
- change asm name of some further implicitely generated builtins
  when using __asm on the builtin function
- fix .note.GNU-stack emitting on IA-32 and AMD64
- fix french translation (#97404, #92059)
- don't build -msoft-float multilibs on ppc* even in -m32

* Tue Jun 10 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-7
- Position Independent Executable support
- .note.GNU-stack marking of object files
- builtin mempcpy, stpcpy, some new builtin memset optimizations
- __attribute__((cleanup)) support (Richard Henderson)
- install unwind.h
- add a gcc driver hack to check reproduceability of ICEs
  and create preproccessed testcase if they are reproduceable

* Mon May  5 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-6
- rebuilt

* Mon May  5 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-5
- fix unwinding location expressions (Richard Henderson)

* Sun May  4 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-4
- comment out -fforced-unwind-exceptions and
  _Unwind_FindEnclosingFunction patches for now until things settle
  down in 3.3

* Tue Apr 29 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-3
- 2 ppc patches from Alan Modra
- allow __REDIRECT on builtins
- add __builtin_memmove and __builtin_bcopy
- support -fforced-unwind-exceptions (Richard Henderson)
- add _Unwind_FindEnclosingFunction to libgcc (Andrew Haley)

* Fri Apr 25 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-2
- 8 ppc patches ported from Alan Modra's collection, including
  new options on ppc64:
  -mtraceback=, -msafe-stack, -mprofile-kernel and -maddr32

* Wed Apr 23 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.3-1
- update from gcc-3_2-branch
  - gcc 3.2.3 release
  - PRs middle-end/10336, c++/10401, 10271, target/10377,
	opt/10352
- fix .eh_frame in libffi assembly so that .eh_frame_hdr table
  is used in libgcj.so
- make sure s390x TLS support is configured in
- fix x86_64 TLS bug

* Sat Apr 12 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-18
- ppc64 libffi
- fix ppc64 unwinder not restoring %r2
- add -mminimal-toc to the build on ppc64
- fix a multilib make -jN race (Ulrich Weigand)
- use --enable-languages list when build_ada is 0
- set build_java to 1 even on ppc64

* Tue Apr  8 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-17
- update from gcc-3_2-branch
  - PRs c/10175, other/6955, middle-end/9967, target/7784, c/8224, ada/9953,
	target/10067, c/8281, target/10114, target/10084, target/7784,
	optimization/10171, optimization/8746, libstdc++/10167
- fix __attribute__((visibility ())) on ppc64

* Mon Apr  7 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-16
- exchange roles of /usr/include/c++/*/ppc-* and /usr/include/c++/*/ppc64-*,
  ppc-* must be a directory

* Sun Apr  6 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-15
- keep the pre-bi-arch ppc -mtune= default (750) instead of
  powerpc introduced in the bi-arch patch.
- handle .save XX, r0 in IA-64 unwinder

* Sat Apr  5 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-14
- ppc bi-arch support
- fix ppc boehm-gc (Tom Tromey)
- fix IA-64 bundling bug (Vlad Makarov, #87580, #87383)

* Fri Mar 28 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-13
- fix dwarf2out stomping on memory (#86441, Zdenek Dvorak, Jason Merrill)

* Wed Mar 26 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-12
- ppc TLS fixes
- ppc SHF_MERGE support

* Tue Mar 25 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-11
- update from gcc-3_2-branch
  - PRs optimization/9414, target/9797, opt/10116, doc-bug/9813,
	optimization/8366, optimization/8746, target/10073,
	target/7248, target/9164, optimization/8396
- fix IT #14363 (Jason Merrill)
- avoid creating temporaries for certain forms of __builtin_expect
- fix s390* reload ICE when compiling --with-__thread glibc (Ulrich Weigand)
- fix IA-64 __sync_{val,bool}_compare_and_swap_si
- initial ppc TLS support (Janis Johnson, Alan Modra)
- require newer binutils (when building and on ppc)

* Fri Mar 14 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-10
- update from gcc-3_2-branch
  - PRs opt/8178, c++/7050, c/9928, optimization/9888
- fix miscompilation of x86_64 kernel
- add -feliminate-unused-debug-types, make it the default (Richard Henderson)

* Thu Mar 13 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-9
- fix ppc bootstrap

* Mon Mar 10 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-8
- update from gcc-3_2-branch
  - PRs optimization/9888, middle-end/7796, optimization/8726, 9954/other,
	c/9799, 9638/other, target/8343, target/9732, 9226, c/5059, c/6126,
	other/9671, libgcj/9652, c++/9602, c++/7982
- fix ICEs in IA-64 kernel compilations in scheduling backport (Vlad Makarov)
- fix typeid with references during optimization (Jason Merrill, #85871)
- fix IA-64 ifcvt bug (#85675)
- use ltoffx if available on IA-64 (Richard Henderson)

* Tue Mar  4 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-7
- IA-64 scheduling backport (Vlad Makarov)
- ppc64 libstdc++ fixes (Alan Modra)
- TLS debug fixes for IA-64 and s390*

* Tue Feb 25 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-5
- update from 3_2-rhl8 branch
  - CANNOT_CHANGE_MODE_CLASS to fix various -march=p4 bugs (Vlad Makarov)
  - fix IA-64 glibc miscompilation (Vlad Makarov, Richard Henderson)
  - one more x86-64 fix for the direct %fs TLS access patch
  - limit memory usage of ios_base_storage.cc testcase

* Mon Feb 24 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-4
- fix ix86_decompose_address broken by last patch
- never use INDNTPOFF on x86-64

* Mon Feb 24 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-3
- update from 3.2 branch
  - PRs other/3782, c/8828, optimization/8613, optimization/9768,
        c/9678, c++/9459
- direct %gs (resp. %fs) TLS access on IA-32 and x86-64 (Richard Henderson)
- don't strip compiler binaries, so that debuginfo is generated for them

* Tue Feb 18 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-2
- update from 3.2 branch
  - PRs c/8068, optimization/7702, libstdc++/9169
- fix dwarf2 ICE on s390 (#81428)
- fix denormalized FP constants in hexadecimal notation (#84383)

* Fri Feb 14 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.2-1
- update from 3.2 branch
  - gcc 3.2.2 release
- backport s390{,x} constant pool fixes from trunk
- fix s390{,x} TLS

* Tue Feb 04 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.1-7
- update from 3.2 branch
- alpha TLS support
- on sparc32 make a symlink in %{_prefix}/include/c++/*/
  to make gcc-c++-sparc32 happy
- add %%{build_java} conditionals (Elliot Lee)
- fix ppc64 dynamic linker path

* Sat Feb 01 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.1-6
- add DW_AT_comp_dir attribute to compilation unit even if the
  main input filename is absolute, but at least one of its includes
  are relative

* Tue Jan 28 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.1-5
- update from 3.2 branch
- backport binds_local_p from HEAD
- s390 TLS
- fix -fPIC on ppc32 (#79732)

* Fri Jan 17 2003 Jakub Jelinek  <jakub@redhat.com> 3.2.1-4
- update from 3.2 branch
  - PRs inline-asm/8832, c/8032, other/8947, preprocessor/8880,
    optimization/8599, optimization/8988, c++/8503, c++/8442,
    c++/8031, libstdc++/9269, libstdc++/8707, libstdc++/9151,
    libstdc++/9168, libstdc++/8887
  - skip over DW_CFA_undefined and DW_CFA_same_value argument (#79424,
    PR libstdc++/9076)
- fix IA-64 C++ TLS tests
- x86-64 Java fixes (Andrew Haley)
- change s390x dynamic linker to /lib64/ld64.so.1

* Wed Dec 11 2002 Jakub Jelinek  <jakub@redhat.com> 3.2.1-3
- update from gcc-3_2-rhl8-branch
  - PR other/8882
- don't remove -lpthread from libgcj.spec

* Mon Dec 09 2002 Jakub Jelinek  <jakub@redhat.com> 3.2.1-2
- update from gcc-3_2-rhl8-branch
  - PRs c/7622, preprocessor/8524, libstdc++/8230, libstdc++/8708,
    libstdc++/8790, libstdc++/7445, libstdc++/6745, libstdc++/8399,
    libstdc++/8230
- fix ?: optimization in arguments of possible sibling calls
- never force_const_mem a TLS SYMBOL_REF (Richard Henderson)
- change -pthread so that it adds -lpthread even if -shared
- fix Ada makefile dependency (Rainer Orth)

* Tue Nov 26 2002 Jakub Jelinek  <jakub@redhat.com> 3.2.1-1
- update from gcc-3_2-rhl8-branch
  - gcc 3.2.1 release
  - PRs c/8639, optimization/8275, c/8588, c/8518, c/8439,
	optimization/8599, 
  - fix .eh_frame section in crtend*.o on x86-64
  - make sure .rodata.cstNN section entries have size sh_entsize
  - readonly .eh_frame and .gcc_except_table section (needs
    binutils change too)
  - fix force_to_mode (#77756)
  - avoid creating invalid subregs in combiner (Dale Johannesen,
    #75046, #75415, #76058, #76526, #78406)
  - avoid using strtok in libstdc++-v3 for thread safety
    (Paolo Carlini, Nathan Myers)
- add Ada for s390

* Sun Nov 17 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-14
- really fix check-abi problem on ia64/alpha

* Sat Nov 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-13
- update from gcc-3_2-rhl8-branch
  - fix flow (Graham Scott, Jan Hubicka)
  - fix check-abi problem on ia64/alpha (Benjamin Kosnik)
  - fix objc on x86_64 (Jan Hubicka, Nicola Pero)
  - fix x86_64 profiling (Jan Hubicka)
  - better s390* .eh_frame encoding (Ulrich Weigand)
- build ada on x86_64
- add fastjar info and jar and grepjar manual pages

* Tue Nov 12 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-12
- update from gcc-3_2-rhl8-branch
  - PRs c/8467, preprocessor/4890, 8502, c/5351, optimization/7591,
    bootstrap/8146, c/8252, optimization/7520, c/8451, c++/8391,
    target/7856, target/7133, target/6890, middle-end/6994, opt/7944,
    c/761, c++/7788, c++/2521, c++/8160, c++/8149, c++/8287,
    middle-end/6994, c++/7266, c++/7228, c++/8067, c++/7679,
    c++/6579, java/7830, libstdc++/8362, libstdc++/8258, libstdc++/7219,
    libstdc++/8466, libstdc++/8172, libstdc++/8197, libstdc++/8318,
    libstdc++/8348, libstdc++/7961, other/3337, bootstrap/6763,
    bootstrap/8122, libstdc++/8347
  - &&lab1 - &&lab2 doesn't need to be in rw section
  - x86_64 %rip fixes
  - fix jar c without f (#77062)
  - backport all fastjar changes from mainline

* Wed Oct 23 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-11
- update from gcc-3_2-rhl8-branch
  - PRs target/7693, opt/7630, c++/6419, target/7396, c++/8218,
    c++/7676, c++/7584, c++/7478, c++/8134, c++/7524, c++/7176,
    c++/5661, c++/6803, c++/7721, c++/7803, c++/7754, c++/7188,
    libstdc++/8071, libstdc++/8127, c++/6745, libstdc++/8096,
    libstdc++/7811
- fix x86-64 ICE with stdarg in -fpic (#76491)
- fix IA-32 miscompilation of DImode code (Jim Wilson, PR target/6981)

* Wed Oct 16 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-10
- update from gcc-3_2-rhl8-branch
  - PRs target/7370, target/8232, opt/7409, preprocessor/7862,
    preprocessor/8190, optimization/6631, target/5610, optimization/7951,
    target/7723
- allow building even if de_DE locale is not installed (#74503, #75889)
- s390x multilib
- x86-64 TLS fixes
- 15 Java fixes (Anthony Green, Andrew Haley, Tom Tromey,
  PRs java/6005, java/7611, java/8003, java/7950, java/5794, libgcj/7073)
- %%define _unpackaged_files_terminate_build 0
- fix make check-abi

* Fri Oct 11 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-9
- update from gcc-3_2-rhl8-branch
  - __attribute__((tls_model("")))
  - PRs c/7353, opt/7124, opt/7912, opt/7390, doc/7484,
        c/7411, target/8087, optimization/6713
- x86-64 TLS

* Tue Oct  8 2002 Jakub Jelinek  <jakub@redhat.com> 3.2-8
- switch to gcc-3_2-rhl8-branch snapshots
  - thus most of the patches went away as they are in CVS
- merge from gcc-3_2-branch between 20020903 and 20021007
  - PRs target/7434, optimization/6627, preprocessor/8120,
	middle-end/7151, preprocessor/8055, optimization/7335,
	c/7160, target/7842, opt/7515, optimization/7130,
	optimization/6984, c/7150, target/7380, other/7114,
	target/5967, optimization/7120, target/7374, opt/7814,
	c/7102
- backported libffi and libjava bits for x86-64 and s390*
- added sparc* support
- multilib setup for sparc* and x86-64
- some IA-32 TLS fixes (Richard Henderson)

* Tue Sep  3 2002 Bill Nottingham <notting@redhat.com> 3.2-7
- fix calling of C++ destructors in certain cases

* Tue Sep  3 2002 Jakub Jelinek <jakub@redhat.com> 3.2-6
- update from CVS (but revert C++ tail padding patches
  for now)
- further fixes to make libstdc++-v3 build on glibc 2.3
- run libstdc++-v3 make check-abi on IA-32 during testing

* Fri Aug 30 2002 Jakub Jelinek <jakub@redhat.com> 3.2-5
- disable tail copy patches, they seem to still have problems
- make libstdc++-v3 build on glibc 2.3 (and use thread-local
  locale model)
- fix c89 and c99 scripts (#73104)

* Wed Aug 26 2002 Jakub Jelinek <jakub@redhat.com> 3.2-4
- reorder alpha_encode_section_info checks slightly to fix an ICE
  when building glibc and to take better advantage of visibility
  attribute on Alpha
- as gdb is not there yet, disable -momit-leaf-frame-pointer
  by default for now on IA-32
- fix IA-64 bootstrap with tail padding patch (Jason Merrill, Daniel Berlin)
- fix x86-64 %RIP to %rip, only output (%rip) if no other relocation
  is used (Richard Henderson)

* Fri Aug 23 2002 Jakub Jelinek <jakub@redhat.com> 3.2-3
- take advantage of __attribute__((visibility())) on Alpha
- avoid copying tail padding (Jason Merrill)

* Thu Aug 22 2002 Jakub Jelinek <jakub@redhat.com> 3.2-2
- fixed Dwarf2 DW_OP_GNU_push_tls_address patch from Richard Henderson
- don't mention removed -a and -ax options in the documentation
  (Nathan Sidwell, #72233)
- fixed __typeof() followed by __asm() redirection from Alexandre Oliva

* Wed Aug 14 2002 Jakub Jelinek <jakub@redhat.com> 3.2-1
- update to 3.2 release
- fix x86-64 PR target/7559 (Jan Hubicka)
- fix -fprefetch-loop-arrays (Janis Johnson)
- fix x86-64 prefetch (Jan Hubicka)

* Fri Aug  9 2002 Jakub Jelinek <jakub@redhat.com> 3.2-0.3
- istream fix (Benjamin Kosnik)
- emit Dwarf2 DW_OP_GNU_push_tls_address extension for TLS (Richard Henderson)
- temporarily disable __typeof() + __asm() fix

* Thu Aug  8 2002 Jakub Jelinek <jakub@redhat.com> 3.2-0.2
- update from 3.2 branch
  - ABI incompatible changes in libstdc++.so.5, long long bitfield
    layout on IA-32 (both C and C++), oversized bitfields layout
    on IA-32 and bitfields with base type with __attribute__((aligned ()))
  - fix strstream segfaults (#68292, Benjamin Kosnik)
- fix __attribute__((visibility())) together with __asm__()
  function redirection
- fix __typeof() followed by __asm() redirection (Alexandre Oliva)
- fix TLS ICE on glibc (#70061)
- fix K6 ICE on linux kernel (#69989, Richard Sandiford, Jan Hubicka)
- fix inlining bug with labels (#70941)
- fix fold-const bug (#70541)
- fix PR preprocessor/7358 (Neil Booth)
- error when mixing __thread and non-__thread declarations
  (#70059, Aldy Hernandez)
- fix TLS bug on g++.dg/tls/diag-1.C (Jason Merrill)
- add -mcmodel= x86-64 documentation (Andreas Jaeger)
- avoid TLS emitting movl %gs:0, MEMORY on IA-32 (#71033)

* Mon Jul 22 2002 Jakub Jelinek <jakub@redhat.com> 3.2-0.1
- first attempt for gcc 3.2
- remove .la files

* Sat Jul 20 2002 Jakub Jelinek <jakub@redhat.com> 3.1-10
- update from 3.1 branch
  - add throw() to set_new_handler (Andreas Schwab)
  - fixed PR optimization/7147, optimization/7153
- make sure pic register is set up even when the only @PLT calls
  are done in EH basic blocks (Richard Henderson)

* Sun Jul 14 2002 Jakub Jelinek <jakub@redhat.com> 3.1-9
- define %%_gnu to nothing for compatibility

* Sat Jul 13 2002 Jakub Jelinek <jakub@redhat.com> 3.1-8
- update from 3.1 branch
  - fix OpenOffice miscompilation (PR c++/7279, Jason Merrill)
  - PRs c++/7224, c++/6255, optimization/7145, c++/6706, preprocessor/7070,
    middle-end/6963, target/6841, target/6770, target/6719,
    other/6836, libstdc++/7057, libstdc++/7097, libstdc++/3946,
    libstdc++/7173
  - fix a GC bug with named labels in C++ (Jim Wilson)
  - fix ICE on Mesa (Bernd Schmidt, #65771)
- added some NRV tests
- fix typo in i386 specs (PR c/7242)
- fix IA-32 ICE with shifts by negative values followed by compare
  (PR middle-end/7245, #68395)
- fixed DWARF-2 output for const char * (PR debug/7241)
- actually enable __cxa_atexit for standard compliance at configury time
- added PPC as Ada enabled architecture

* Wed Jun 19 2002 Jakub Jelinek <jakub@redhat.com> 3.1-7
- update from 3.1 branch
  - PRs target/6922, opt/6722, c/7030, c/6677, objc/6834, c++/6892,
    c++/6723, opt/6793
- use __cxa_atexit for standard compliance:
  if your C++ project knows it won't call atexit from within its
  static constructors, use -fno-use-cxa-atexit to optimize it
- share hard register rtxs where possible to speed the compiler up (Jeff Law)
- optimize tree_code_* arrays (Kaveh Ghazi)
- don't link prefix.o into libgnat, link libgnat against libgcc_s and
  libgnarl against libgnat
- fix typo in GNAT %%post (#66847, #66941, #66639)
- add TLS support

* Fri Jun  7 2002 Jakub Jelinek <jakub@redhat.com> 3.1-6
- add GNAT
- remove DT_RPATH from Java binaries (#66103)
- obsolete kaffe, install jar as %{_prefix}/bin/jar
- add include/org directory in java
- add rmic and rmiregistry programs to libgcj
- add info documentation for gcj and various man pages
- add message catalogues for da, el, es, fr, ja, nl, sv, tr
- don't put IA-64 vtables with relocations into read-only sections
  with -fpic

* Tue Jun  4 2002 Jakub Jelinek <jakub@redhat.com> 3.1-5
- update from 3.1 branch
  - PRs optimization/6822, preprocessor/6844, target/6838, target/6788,
	libstdc++/6886, libstdc++/6795, libstdc++/6811
- m$ compatibility for unnamed fields as typedef of struct/union
  (PR c/6660)
- fix -fverbose-asm with unnamed fields (PR c/6809)
- fix -mmmx ICE (PR optimization/6842)
- default to -momit-leaf-frame-pointer on i386 (Richard Henderson)
- use linkonce section/hidden symbol for i686 pic getpc thunks
  (Richard Henderson)

* Tue May 28 2002 Jakub Jelinek <jakub@redhat.com> 3.1-4
- rebuilt

* Sat May 25 2002 Jakub Jelinek <jakub@redhat.com> 3.1-3
- update from 3.1 branch
  - PRs other/6782, preprocessor/6780, preprocessor/6517,
	libstdc++/6282, libstdc++/6701, libstdc++/6701
  - fix out << "" bug (Ben Kosnik, #65409, PR libstdc++/6750)
- 3 new patches
  - fix C++ __PRETTY_FUNCTION__ (PR c++/6794)
  - fix ICE on jikes (#65379)
  - add test for fixed mozilla miscompilation
- include intrinsic headers on IA-32/x86-64, include altivec.h on PPC

* Wed May 22 2002 Jakub Jelinek <jakub@redhat.com> 3.1-2
- update from 3.1 branch
- 8 new patches
  - fix as version test for 2.12.1 and newer binutils non-CVS releases
  - fix ICE in do_subst (#65049)
  - fix SSE conditional move (PR target/6753)
  - fix SPARC CSE ICE (PR optimization/6759)
  - fix x86_64 dbx64_register_map typo (Jan Hubicka)
  - fix DWARF-2 with flag_asynchronous_unwind_tables set for leaf
    functions (Jan Hubicka)
  - fix DWARF-2 x86_64 __builtin_dwarf_reg_sizes (Jan Hubicka)
  - fix x86_64 movabsdi (Michael Matz)

* Wed May 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-1
- update to 3.1 final
- 15 new patches
  - fix PR c/6643
  - fix fold-const.c typo
  - fix unitialized pointer-to-member values (Alexandre Oliva)
  - fix templates with asm inputs (Jason Merrill)
  - fix -fdata-section (Andreas Schwab)
  - readd warning about i386 -malign-double into documentation (Jan Hubicka)
  - fix PR libstdc++/6594 (Ben Kosnik)
  - fix PR PR libstdc++/6648 (Paolo Carlini)
  - fix libstdc++ testsuite rlimits (Rainer Orth)
  - s390 java support (Gerhard Tonn)
  - rotate testcases (Tom Rix)
  - build libiberty with -fpic on x86_64 (Andreas Schwab)
  - fix x86_64 multilib build (Bo Thorsen)
  - fix x86_64 ASM_OUTPUT_MI_THUNK (Jan Hubicka)
  - fix loop-2[cd].c tests on i386 (Eric Botcazou)
- fix typo in g77 info files tweaking
- fix libgcj.so symlink

* Thu May  9 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.28
- update to CVS 3.1 branch
  - PR c++/6212, target/6429, opt/6534, c/6543, target/6561, c/6569
- fix x86_64 q_regs_operand (Jan Hubicka)
- better PR c++/6381 fix (Jason Merrill)

* Fri May  3 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.27
- update to CVS 3.1 branch
  - PR target/5628, libstdc++/5820, c++/6396, preprocessor/6489,
    libstdc++/6501, libstdc++/6511, target/6512, libstdc++/6513,
    bootstrap/6514, opt/6516, bootstrap/6525, c++/6527, libstdc++/6533,
    target/6540
- fix PR target/6542, target/6522, libstdc++/6549

* Mon Apr 29 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.26
- update to CVS 3.1 branch
  - PR c/3581, libstdc++/4150, libstdc++/4164, c/5154, c/5430, c++/5504,
    c++/5658, c++/5719, f/6138, libgcj/6158, middle-end/6205, c++/6256,
    c/6300, c++/6331, c/6343, c/6344, c++/6352, c/6358, libstdc++/6360,
    c++/6395, target/6413, libstdc++/6414, target/6422, bootstrap/6445,
    optimization/6475, target/6476, c++/6477, c++/6479, c++/6486, c++/6492,
    target/6494, target/6496, c/6497, target/6500
- fix PR c++/6396
- run make check as part of build process

* Thu Apr 18 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.25
- update to CVS 3.1 branch
  - PR opt/420, c++/525, target/817, target/1538, opt/3967, target/3997,
    opt/4120, bootstrap/4191, opt/4311, optimization/4328, c++/4884, c++/4934,
    c/5078, c++/5104, opt/5120, c++/5189, c++/5373, target/5446, c/5484,
    c++/5507, c++/5571, c++/5636, target/5672, target/5715, target/5886,
    c++/5933, c++/5964, c++/5998, opt/6007, target/6032, target/6041,
    target/6054, c++/6073, target/6082, optimization/6086, target/6087,
    middle-end/6096, middle-end/6098, middle-end/6099, middle-end/6100,
    middle-end/6102, fortran/6106, c++/6119, opt/6165, optimization/6177,
    c++/6179, optimization/6189, c/6202, c/6223, optimization/6233,
    middle-end/6279, c/6290, optimization/6305, target/6305, bootstrap/6315,
    c++/6320...
- fix PR c++/6316

* Wed Mar 27 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.24
- update to CVS 3.1 branch
  - PRs c/5656, c/5972, bootstrap/4192, target/4792, bootstrap/4195,
    optimization/5854, target/6043, c++/6037, bootstrap/4128, target/5740,
    c/5597, optimization/5863, optimization/5742, target/3177, c/5354,
    optimization/5999, target/5977, middle-end/5731, target/5312...

* Fri Mar 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.23.1
- fix info and man page generation

* Thu Mar 14 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.23
- update to CVS 3.1 branch
  - fix IA-64 packet selection (PR optimization/5892)
  - make highest_pow2_factor work for all constants (PR middle-end/5877)
  - fix -Wunused (#61047)
  - fix loop on mixed mode class assignments (#60923)
  - fix wide character literals
  - support SPARC v9 long distance branches (PR target/5626)
  - fix SPARC leaf functions
  - fix a rtl sharing problem (Richard Henderson, #60760,
    PR optimization/5844)
  - fix va_arg with variable size types (PR c/3711)
  - PRs optimization/5901, optimization/5878, 5693, preprocessor/5899
- fix C++ ?: at the end of stmt expr (PR c++/5373)
- fix loop unrolling with sibcalls (PR optimization/5891)

* Thu Mar  7 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.22
- update to CVS 3.1 branch
  - fix ICE with volatile long long (#60650)
  - fix tempbuf.h (Philipp Thomas, #60212)
  - fix -fssa-ccp (Jeff Law, #60651)
  - versioned libstdc++
  - backport __attribute__((visibility("..."))) patches from trunk
- include libstdc++ html documentation

* Tue Feb  5 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.21
- update to CVS HEAD
  - fix demangler (H.J. Lu, #59300, #59310)
  - fix typo in IA-32 specs file (#59081)
  - support moving SFmode values in MMX regs if -mmmx (#59083)
  - fix recog_for_combine (#59084)
  - don't ICE when inserting insns on edge from bb0 to bb0 (Bernd Schmidt,
    #59087)
  - make sure configure has not time in the future (#59203)
  - fix division/modulo by certain constants (#58065, PR c/5304)
  - fix -Wswitch (PR c/4475)

* Thu Jan 31 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.20
- update to CVS HEAD
  - fix jar (Tom Tromey)
  - fix loop unrolling (Richard Henderson)

* Wed Jan 30 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.19
- update to CVS HEAD
  - fix a reload bug on ia32 (#58579, #58648)
  - issue error about unknown -W* options (#58909)
  - fix ia64 libbfd miscompilation (#58694)
  - register all pending unparsed_text structures with GC (#58647)
  - fix __builtin_apply with ia32 -msse (#58447)
  - prevent ia64 prologue insns saving regs required for eh from being
    deleted (#58387)

* Tue Jan 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.18
- update to CVS HEAD
  - handle static x[] = { [X...Y] = (foo) { Z } } (#58338)
  - fix getdents.os miscompilation (Richard Henderson, #58308)
  - fix ICE in try_forward_edges (#58125)
  - fix ICE with -fexceptions -foptimize-sibling-calls

* Tue Jan  8 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.17
- avoid division by 0 when computing prediction probabilities (#57992)
- fix ICE due to store_expr not adjusting value back for mode
- increase -ftemplate-depth default value to 500

* Mon Jan  7 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.16
- if using PT_GNU_EH_FRAME registry, work around assembler bug resp. feature
  and don't provide weak prototypes of functions which won't be used
- on Alpha, fix a typo so that crtbeginT.o is built and installed
- fix glibc inl-tester miscompilation on ia32

* Sun Jan  6 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.15
- update to CVS HEAD (fix glibc bootstrap failure)

* Thu Jan  3 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.14
- update to CVS HEAD (#57907)
  - fix alpha bootstrap (Richard Henderson)
- fix simplification of (div:SI (???:DI ???) (const_int 1))
  (#57916)
- add contrib/gcc_update --touch

* Tue Jan  1 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.13
- update to CVS HEAD (fix glibc miscompilation on alpha)
- fix objc to not emit __objc_class_name_* without type and size

* Mon Dec 31 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.12
- update to CVS HEAD
- fix sed commands for .la files
- make Alpha use PT_GNU_EH_FRAME

* Thu Dec 27 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.11
- update to CVS HEAD (#57165, #57212, #57467, #57488, #57502,
  #57505, #57574)
- readd .la files after fixing them up by sed
- add %%defattr(-,root,root) to libobjc subpackage

* Mon Dec  3 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.10
- one more gcc.spec fix for passing --gdwarf-2 resp. --gstabs to as
- fix conditional register dead computation on IA-64
- fix extern array of incomplete structures handling
- fix gcc -xc -
- fix Fortran ICEs with SAVE_EXPRs (Richard Kenner)

* Tue Nov 27 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.9
- update to CVS HEAD
- make DWARF 2 preferred debugging format on Linux

* Mon Nov 12 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.8
- don't ship .la files (#56072)
- include libfrtbegin.a (#56098)

* Mon Nov 12 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.7
- update to CVS HEAD
- back out Nov 7th loop.c change for now

* Fri Nov  9 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.6
- update to CVS HEAD
- frame unwind compatibility with 7.[12] binutils

* Tue Nov  6 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.5
- update to CVS HEAD
- merge DW_EH_PE_indirect constants and their relocs

* Thu Oct 25 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.4
- don't loop forever or ICE on bogus array initializers (#53704)
- fix store motion with pure calls
- disable store motion for now

* Tue Oct 23 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.3
- fix inlining of C nested functions with auto prototypes

* Mon Oct 22 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.2
- update to CVS HEAD
- tree inlining fix from Alexandre Oliva
- fix anonymous union ICE on alpha

* Mon Oct 15 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.1
- switch package to main compiler from alternate compiler
- update to CVS HEAD
- early gcc-2.96-RH compatibility in __frame_state_for
- change weak function tests for functions always present in GLIBC 2.2
  into simple non-weak calls in crt*.o to avoid unnecessary symbol
  lookups and prelink conflicts
- don't link against libgcc_s C shared libraries

* Tue Oct  2 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-4
- update from CVS 3.0 branch
  - ia64 function descriptors in vtables
- handle large files in Fortran (#53328)
- allow Java programs to be statically linked (#53605)
- remove #include_next patch, Benjamin commited it

* Thu Sep  6 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-3
- don't use #include_next in <bits/std_c*> headers (Benjamin Kosnik, #53262)

* Wed Sep  5 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-2
- update from CVS 3.0 branch
- check all gcc-2.96-RH patches whether they have made it into 3.0.1,
  and if not, whether they are appropriate for 3.0.1
- 8 new patches
  - add 36 testcases from gcc-2.96-RH
  - fix ICE on very questionable C++ code from JDK (#39858, #52960)
  - fix -frepo (Nathan Sidwell, #52877)
  - avoid generating bogus .stabs (#49214)
  - issue a clear error message about invalid ia32 floating point
    asm constraints (#27137)
  - fix some comment typos
  - fix ADDRESSOF recognition (#29686)

* Mon Aug 27 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-1
- update from CVS (3.0.1 final)
- properly handle throw() exception specifiers in template decls (#51824)
- fix IA-64 varargs handling in presence of additional anonymous arguments
  (#50757)
- fix boehm-gc for prelink
- fix a typo in gcc3-c++ description (#52323)
- remove Chill from package summary (#51764)

* Tue Aug  7 2001 Jakub Jelinek <jakub@redhat.com> 3.0-6
- update from CVS
  - fix glibc vfprintf miscompilation
- don't warn about if (&foo) if foo is weak (H.J.Lu, #50855)

* Wed Jul 25 2001 Jakub Jelinek <jakub@redhat.com> 3.0-5
- include libgcjgc.a in libgcj3-devel
- include libgcjgc.so.* in libgcj3 on ia64
- remove dependency on libgcj on ia64
- add ldconfig to libgcj3 post/postun

* Tue Jul 24 2001 Jakub Jelinek <jakub@redhat.com> 3.0-4
- update from CVS
- make gcc3-java/libgcj3* packages, so that they can coexist
  with 2.96-RH Java
- make sure shared Java libraries are built with proper dependencies

* Wed Jul 11 2001 Jakub Jelinek <jakub@redhat.com> 3.0-3
- fix libgcc_s.so and libstdc++.so symlinks
- don't ship jar

* Tue Jul 10 2001 Jakub Jelinek <jakub@redhat.com> 3.0-2
- move libstdc++.so into gcc-lib
- add libobjc.so symlink

* Tue Jul 10 2001 Jakub Jelinek <jakub@redhat.com> 3.0-1
- new rpm
